class ViewAddForm

Same name and namespace in other branches
  1. 11.x core/modules/views_ui/src/ViewAddForm.php \Drupal\views_ui\ViewAddForm
  2. 10 core/modules/views_ui/src/ViewAddForm.php \Drupal\views_ui\ViewAddForm
  3. 9 core/modules/views_ui/src/ViewAddForm.php \Drupal\views_ui\ViewAddForm
  4. 8.9.x core/modules/views_ui/src/ViewAddForm.php \Drupal\views_ui\ViewAddForm

Form controller for the Views add form.

@internal

Hierarchy

Expanded class hierarchy of ViewAddForm

File

core/modules/views_ui/src/ViewAddForm.php, line 18

Namespace

Drupal\views_ui
View source
class ViewAddForm extends ViewFormBase {
  use ViewsFormAjaxHelperTrait;
  
  /**
   * The wizard plugin manager.
   *
   * @var \Drupal\views\Plugin\ViewsPluginManager
   */
  protected $wizardManager;
  
  /**
   * The module handler service.
   *
   * @var \Drupal\Core\Extension\ModuleHandlerInterface
   */
  protected $moduleHandler;
  
  /**
   * Constructs a new ViewAddForm object.
   *
   * @param \Drupal\views\Plugin\ViewsPluginManager $wizard_manager
   *   The wizard plugin manager.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler service.
   */
  public function __construct(ViewsPluginManager $wizard_manager, ModuleHandlerInterface $module_handler) {
    $this->wizardManager = $wizard_manager;
    $this->moduleHandler = $module_handler;
  }
  
  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static($container->get('plugin.manager.views.wizard'), $container->get('module_handler'));
  }
  
  /**
   * {@inheritdoc}
   */
  protected function prepareEntity() {
    // Do not prepare the entity while it is being added.
  }
  
  /**
   * {@inheritdoc}
   */
  public function form(array $form, FormStateInterface $form_state) {
    $form['#attached']['library'][] = 'views_ui/views_ui.admin';
    $form['#attributes']['class'] = [
      'views-admin',
    ];
    $form['name'] = [
      '#type' => 'fieldset',
      '#title' => $this->t('View basic information'),
      '#attributes' => [
        'class' => [
          'fieldset-no-legend',
        ],
      ],
    ];
    $form['name']['label'] = [
      '#type' => 'textfield',
      '#title' => $this->t('View name'),
      '#required' => TRUE,
      '#size' => 32,
      '#default_value' => '',
      '#maxlength' => 255,
    ];
    $form['name']['id'] = [
      '#type' => 'machine_name',
      '#maxlength' => 128,
      '#machine_name' => [
        'exists' => '\\Drupal\\views\\Views::getView',
        'source' => [
          'name',
          'label',
        ],
      ],
      '#description' => $this->t('A unique machine-readable name for this View. It must only contain lowercase letters, numbers, and underscores.'),
    ];
    $form['name']['description_enable'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Description'),
    ];
    $form['name']['description'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Provide description'),
      '#title_display' => 'invisible',
      '#size' => 64,
      '#default_value' => '',
      '#states' => [
        'visible' => [
          ':input[name="description_enable"]' => [
            'checked' => TRUE,
          ],
        ],
      ],
    ];
    // Create a wrapper for the entire dynamic portion of the form. Everything
    // that can be updated by AJAX goes somewhere inside here. For example, this
    // is needed by "Show" dropdown (below); it changes the base table of the
    // view and therefore potentially requires all options on the form to be
    // dynamically updated.
    $form['displays'] = [];
    // Create the part of the form that allows the user to select the basic
    // properties of what the view will display.
    $form['displays']['show'] = [
      '#type' => 'fieldset',
      '#title' => $this->t('View settings'),
      '#tree' => TRUE,
      '#attributes' => [
        'class' => [
          'container-inline',
        ],
      ],
    ];
    // Create the "Show" dropdown, which allows the base table of the view to be
    // selected.
    $wizard_plugins = $this->wizardManager
      ->getDefinitions();
    $options = [];
    foreach ($wizard_plugins as $key => $wizard) {
      $options[$key] = $wizard['title'];
    }
    $form['displays']['show']['wizard_key'] = [
      '#type' => 'select',
      '#title' => $this->t('Show'),
      '#options' => $options,
      '#sort_options' => TRUE,
    ];
    $show_form =& $form['displays']['show'];
    $default_value = $this->moduleHandler
      ->moduleExists('node') ? 'node' : 'users';
    $show_form['wizard_key']['#default_value'] = WizardPluginBase::getSelected($form_state, [
      'show',
      'wizard_key',
    ], $default_value, $show_form['wizard_key']);
    // Changing this dropdown updates the entire content of $form['displays']
    // via AJAX.
    $this->addAjaxTrigger($show_form, 'wizard_key', [
      'displays',
    ]);
    // Build the rest of the form based on the currently selected wizard plugin.
    $wizard_key = $show_form['wizard_key']['#default_value'];
    $wizard_instance = $this->wizardManager
      ->createInstance($wizard_key);
    $form = $wizard_instance->buildForm($form, $form_state);
    return $form;
  }
  
  /**
   * {@inheritdoc}
   */
  protected function actions(array $form, FormStateInterface $form_state) {
    $actions = parent::actions($form, $form_state);
    $actions['submit']['#value'] = $this->t('Save and edit');
    // Remove EntityFormController::save() form the submission handlers.
    $actions['submit']['#submit'] = [
      [
        $this,
        'submitForm',
      ],
    ];
    $actions['cancel'] = [
      '#type' => 'submit',
      '#value' => $this->t('Cancel'),
      '#submit' => [
        '::cancel',
      ],
      '#limit_validation_errors' => [],
    ];
    return $actions;
  }
  
  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    $wizard_type = $form_state->getValue([
      'show',
      'wizard_key',
    ]);
    $wizard_instance = $this->wizardManager
      ->createInstance($wizard_type);
    $form_state->set('wizard', $wizard_instance->getPluginDefinition());
    $form_state->set('wizard_instance', $wizard_instance);
    $path =& $form_state->getValue([
      'page',
      'path',
    ]);
    if (!empty($path)) {
      // @todo https://www.drupal.org/node/2423913 Views should expect and store
      //   a leading /.
      $path = ltrim($path, '/ ');
    }
    $errors = $wizard_instance->validateView($form, $form_state);
    foreach ($errors as $display_errors) {
      foreach ($display_errors as $name => $message) {
        $form_state->setErrorByName($name, $message);
      }
    }
  }
  
  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    try {
      /** @var \Drupal\views\Plugin\views\wizard\WizardInterface $wizard */
      $wizard = $form_state->get('wizard_instance');
      $this->entity = $wizard->createView($form, $form_state);
    } catch (WizardException $e) {
      $this->messenger()
        ->addError($e->getMessage());
      $form_state->setRedirect('entity.view.collection');
      return;
    }
    $this->entity
      ->save();
    $this->messenger()
      ->addStatus($this->t('The view %name has been saved.', [
      '%name' => $form_state->getValue('label'),
    ]));
    $form_state->setRedirectUrl($this->entity
      ->toUrl('edit-form'));
  }
  
  /**
   * Form submission handler for the 'cancel' action.
   *
   * @param array $form
   *   An associative array containing the structure of the form.
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   *   The current state of the form.
   */
  public function cancel(array $form, FormStateInterface $form_state) {
    $form_state->setRedirect('entity.view.collection');
  }

}

Members

Title Sort descending Modifiers Object type Summary Overriden Title Overrides
AutowiredInstanceTrait::createInstanceAutowired public static function Instantiates a new instance of the implementing class using autowiring.
AutowiredInstanceTrait::getAutowireArguments private static function Resolves arguments for a method using autowiring.
DependencySerializationTrait::$_entityStorages protected property An array of entity type IDs keyed by the property name of their storages.
DependencySerializationTrait::$_serviceIds protected property An array of service IDs keyed by property name used for serialization.
DependencySerializationTrait::__sleep public function 2
DependencySerializationTrait::__wakeup public function 2
EntityForm::$entity protected property The entity being used by this form. 10
EntityForm::$entityTypeManager protected property The entity type manager. 3
EntityForm::$operation protected property The name of the current operation.
EntityForm::actionsElement protected function Returns the action form element for the current entity form.
EntityForm::afterBuild public function Form element #after_build callback: Updates the entity with submitted data. 1
EntityForm::buildEntity public function Overrides EntityFormInterface::buildEntity 5
EntityForm::copyFormValuesToEntity protected function Copies top-level form values to entity properties. 12
EntityForm::getBaseFormId public function Overrides BaseFormIdInterface::getBaseFormId 3
EntityForm::getCallableFromDefinition protected function Gets a callable from a string or array definition if possible.
EntityForm::getEntity public function Overrides EntityFormInterface::getEntity
EntityForm::getEntityFromRouteMatch public function Overrides EntityFormInterface::getEntityFromRouteMatch 3
EntityForm::getFormId public function Overrides FormInterface::getFormId 14
EntityForm::getOperation public function Overrides EntityFormInterface::getOperation
EntityForm::prepareInvokeAll protected function Invokes the specified prepare hook variant.
EntityForm::processForm public function Process callback: assigns weights and hides extra fields.
EntityForm::save public function Overrides EntityFormInterface::save 45
EntityForm::setEntity public function Overrides EntityFormInterface::setEntity
EntityForm::setEntityTypeManager public function Overrides EntityFormInterface::setEntityTypeManager
EntityForm::setModuleHandler public function Overrides EntityFormInterface::setModuleHandler
EntityForm::setOperation public function Overrides EntityFormInterface::setOperation
FormBase::$configFactory protected property The config factory. 1
FormBase::$requestStack protected property The request stack. 1
FormBase::$routeMatch protected property The route match.
FormBase::config protected function Retrieves a configuration object.
FormBase::configFactory protected function Gets the config factory for this form. 1
FormBase::container private function Returns the service container.
FormBase::currentUser protected function Gets the current user. 2
FormBase::getRequest protected function Gets the request object. Overrides HtmxRequestInfoTrait::getRequest
FormBase::getRouteMatch protected function Gets the route match.
FormBase::logger protected function Gets the logger for a specific channel.
FormBase::redirect protected function Returns a redirect response object for the specified route.
FormBase::resetConfigFactory public function Resets the configuration factory.
FormBase::setConfigFactory public function Sets the config factory for this form.
FormBase::setRequestStack public function Sets the request stack object to use.
HtmxRequestInfoTrait::getHtmxCurrentUrl protected function Retrieves the URL of the requesting page from an HTMX request header.
HtmxRequestInfoTrait::getHtmxPrompt protected function Retrieves the prompt from an HTMX request header.
HtmxRequestInfoTrait::getHtmxTarget protected function Retrieves the target identifier from an HTMX request header.
HtmxRequestInfoTrait::getHtmxTrigger protected function Retrieves the trigger identifier from an HTMX request header.
HtmxRequestInfoTrait::getHtmxTriggerName protected function Retrieves the trigger name from an HTMX request header.
HtmxRequestInfoTrait::isHtmxBoosted protected function Determines if the request is boosted by HTMX.
HtmxRequestInfoTrait::isHtmxHistoryRestoration protected function Determines if if the request is for history restoration.
HtmxRequestInfoTrait::isHtmxRequest protected function Determines if the request is sent by HTMX.
LoggerChannelTrait::$loggerFactory protected property The logger channel factory service.
LoggerChannelTrait::getLogger protected function Gets the logger for a specific channel.
LoggerChannelTrait::setLoggerFactory public function Injects the logger channel factory.
MessengerTrait::$messenger protected property The messenger. 26
MessengerTrait::messenger public function Gets the messenger. 26
MessengerTrait::setMessenger public function Sets the messenger.
RedirectDestinationTrait::$redirectDestination protected property The redirect destination service. 2
RedirectDestinationTrait::getDestinationArray protected function Prepares a 'destination' URL query parameter for use with \Drupal\Core\Url.
RedirectDestinationTrait::getRedirectDestination protected function Returns the redirect destination service.
RedirectDestinationTrait::setRedirectDestination public function Sets the redirect destination service.
StringTranslationTrait::$stringTranslation protected property The string translation service. 3
StringTranslationTrait::formatPlural protected function Formats a string containing a count of items.
StringTranslationTrait::getNumberOfPlurals protected function Returns the number of plurals supported by a given language.
StringTranslationTrait::getStringTranslation protected function Gets the string translation service.
StringTranslationTrait::setStringTranslation public function Sets the string translation service to use. 2
StringTranslationTrait::t protected function Translates a string to the current language or to a given language. 1
ViewAddForm::$moduleHandler protected property The module handler service. Overrides EntityForm::$moduleHandler
ViewAddForm::$wizardManager protected property The wizard plugin manager.
ViewAddForm::actions protected function Overrides EntityForm::actions
ViewAddForm::cancel public function Form submission handler for the 'cancel' action.
ViewAddForm::create public static function Overrides AutowireTrait::create
ViewAddForm::form public function Overrides EntityForm::form
ViewAddForm::prepareEntity protected function Overrides ViewFormBase::prepareEntity
ViewAddForm::submitForm public function Overrides EntityForm::submitForm
ViewAddForm::validateForm public function Overrides FormBase::validateForm
ViewAddForm::__construct public function Constructs a new ViewAddForm object.
ViewFormBase::$displayID protected property The name of the display used by the form.
ViewFormBase::buildForm public function Overrides EntityForm::buildForm
ViewFormBase::getDisplayLabel public function Placeholder function for overriding $display['display_title'].
ViewFormBase::getDisplayTabs public function Adds tabs for navigating across Displays when editing a View.
ViewFormBase::init public function Overrides EntityForm::init
ViewFormBase::isDefaultDisplayShown public function Returns whether or not the default display should have its own tab on edit.
ViewsFormAjaxHelperTrait::$ajaxTriggerButtons protected static property Memory cache for processed buttons.
ViewsFormAjaxHelperTrait::addAjaxTrigger protected function Converts a form element in the new view wizard to be AJAX-enabled.
ViewsFormAjaxHelperTrait::addAjaxWrapper public static function Adds a wrapper to a form region (for AJAX refreshes) after the build.
ViewsFormAjaxHelperTrait::addLimitedValidation public static function Limits validation errors for a non-JavaScript fallback submit button.
ViewsFormAjaxHelperTrait::ajaxUpdateForm public function Provides a triggering element Ajax callback.
ViewsFormAjaxHelperTrait::getElementInfo protected function Returns the element info plugin manager.
ViewsFormAjaxHelperTrait::noJsSubmit public static function Provides a callback for non-JavaScript submit.

Buggy or inaccurate documentation? Please file an issue. Need support? Need help programming? Connect with the Drupal community.